/**********************************************************************
;       Copyright 2005 Summit Soft Consulting
;
;                       RESTRICTED RIGHTS LEGEND
;                       ------------------------
;
; Use, duplication, or disclosure by any commercial industry (public
; or private), private individual, or by any Government Agency without
; a express written consent of release from Summit Soft Consulting
; is subject to restrictions as set forth in paragraph (b) (3) (B) of
; the Rights in Technical Data and Computer Software clause in
; DAR 7-104.9 (a).  Manufacturer is: Summit Soft Consulting,
; 26895 Aliso Creek Rd. Suite B504, Aliso Viejo, CA 92656,
; http://www.SummitSoftConsulting.com
;**********************************************************************/

#include "stdafx.h"
#include <windows.h>
#include <crtdbg.h>
#include "..\pciexdrv\IntrFace.h"
#include "PciExDrvTestApp.h"
#include "PciFunction.h"

void TestCppStuff(HANDLE hDriver)
{
	// Create the CHostBridge root node.
	// This reads in and creates all PCI functions in memory.
	CPciFunction HostBridge(hDriver);

	// Print out the most important information.
	HostBridge.Dump();

	// Test: Modify some configuration space registers of a known 
	// PCI function and write it back to the PCI function.
//	CPciFunction * pPciFunction = HostBridge.Find(2, 3, 1);
//	CPciFunction * pPciFunction = HostBridge.Find(3, 4, 0); // cLAN
	CPciFunction * pPciFunction = HostBridge.Find(3, 7, 0);	// PLX
	_ASSERTE(pPciFunction);

	// Modify some registers of the device.
//	pPciFunction->GetPciHeader()->Type0Hdr.ulBAR5 = 0x12345678;
//	pPciFunction->GetPciHeader()->Type0Hdr.usCommandRegister = 0x1234;
//	pPciFunction->GetPciHeader()->Type0Hdr.ucMinGnt = 0x12;
//	pPciFunction->WriteChanges();

	// Read/Modify/Write a known BAR.
	UCHAR vucDeviceData[256];
	BOOL bSuccess = pPciFunction->ReadDeviceData(0, 0, vucDeviceData, 1, 256);
	_ASSERTE(bSuccess);
	for(int i=0; i<256; i++)
	{
		vucDeviceData[i] = i;
	}
	bSuccess = pPciFunction->WriteDeviceData(0, 0, vucDeviceData, 1, 256);
	_ASSERTE(bSuccess);

	// Read/modify/Write to I/O BAR.
	bSuccess = pPciFunction->ReadDeviceData(1, 0, vucDeviceData, 1, 256);
	_ASSERTE(bSuccess);
	for(int i=0; i<256; i++)
	{
		vucDeviceData[i] = i;
	}
	bSuccess = pPciFunction->WriteDeviceData(1, 0, vucDeviceData, 1, 256);
	_ASSERTE(bSuccess);


}

int _tmain(int argc, _TCHAR* argv[])
{
	// Open handle to driver.
    HANDLE hDriver = CreateFile(
		_T("\\\\.\\pciexdrvDevice"),
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		0,
		0
		);
	_ASSERTE(hDriver);

	TestCppStuff(hDriver);

	return 0;
}