/**********************************************************************
;       Copyright 2005 Summit Soft Consulting
;
;                       RESTRICTED RIGHTS LEGEND
;                       ------------------------
;
; Use, duplication, or disclosure by any commercial industry (public
; or private), private individual, or by any Government Agency without
; a express written consent of release from Summit Soft Consulting
; is subject to restrictions as set forth in paragraph (b) (3) (B) of
; the Rights in Technical Data and Computer Software clause in
; DAR 7-104.9 (a).  Manufacturer is: Summit Soft Consulting,
; 26895 Aliso Creek Rd. Suite B504, Aliso Viejo, CA 92656,
; http://www.SummitSoftConsulting.com
;**********************************************************************/

#pragma once

typedef enum TABPANETYPE{
	ConfigSpacePane,
	BarPane
};

class CPciFunction;

class CAbstractTabPane
{
public:

	CAbstractTabPane(){};
	virtual ~CAbstractTabPane(){}

	virtual void OnSize(UINT nType, int cx, int cy) = 0;
	virtual void ActivatePane() = 0;
	virtual void DeactivatePane() = 0;
	virtual void ShowPciFunction(CPciFunction * pPciFunction = NULL) = 0;
	virtual void SetHexadecimalDisplay(BOOL bHexadecimal) = 0;
	virtual void OnValueEdited(int iItemEdited, int iSubItemEdited, char * pszNewValue) = 0;
	virtual TABPANETYPE GetType() = 0;
	virtual void OnContextMenu(CWnd* pWnd, CPoint point) = 0;
	virtual void OnRefresh() = 0;
};
