/**********************************************************************
;       Copyright 2005 Summit Soft Consulting
;
;                       RESTRICTED RIGHTS LEGEND
;                       ------------------------
;
; Use, duplication, or disclosure by any commercial industry (public
; or private), private individual, or by any Government Agency without
; a express written consent of release from Summit Soft Consulting
; is subject to restrictions as set forth in paragraph (b) (3) (B) of
; the Rights in Technical Data and Computer Software clause in
; DAR 7-104.9 (a).  Manufacturer is: Summit Soft Consulting,
; 26895 Aliso Creek Rd. Suite B504, Aliso Viejo, CA 92656,
; http://www.SummitSoftConsulting.com
;**********************************************************************/

#pragma once

#include "PciFunction.h"

class CPciBusView : public CTreeView
{
	DECLARE_DYNCREATE(CPciBusView)

protected:
	CPciBusView();           // protected constructor used by dynamic creation
	virtual ~CPciBusView();

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	////////////////////////////
	// Member variables.
	////////////////////////////

	// This is the tree control that CTreeView wraps.
	CTreeCtrl * m_pTreeCtrl;

	// This image list contains the bitmaps shown in the tree view nodes.
	CImageList m_imageList;

	////////////////////////////
	// Helper functions.
	////////////////////////////

	void  m_AddNodesToTreeControl(HTREEITEM hParent, CPciFunction * pPciFunction);
	int m_GetImageIndex(CPciFunction * pPciFunction);

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual void OnInitialUpdate();
	afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);
protected:
	virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
public:
	afx_msg void OnRefresh();
};


