/**********************************************************************
;       Copyright 2005 Summit Soft Consulting
;
;                       RESTRICTED RIGHTS LEGEND
;                       ------------------------
;
; Use, duplication, or disclosure by any commercial industry (public
; or private), private individual, or by any Government Agency without
; a express written consent of release from Summit Soft Consulting
; is subject to restrictions as set forth in paragraph (b) (3) (B) of
; the Rights in Technical Data and Computer Software clause in
; DAR 7-104.9 (a).  Manufacturer is: Summit Soft Consulting,
; 26895 Aliso Creek Rd. Suite B504, Aliso Viejo, CA 92656,
; http://www.SummitSoftConsulting.com
;**********************************************************************/

#include "stdafx.h"
#include "PciExplorer.h"

#include "PciExplorerDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNCREATE(CPciExplorerDoc, CDocument)

BEGIN_MESSAGE_MAP(CPciExplorerDoc, CDocument)
END_MESSAGE_MAP()

CPciExplorerDoc::CPciExplorerDoc()
{
	// Open handle to driver.
	m_hDriver = CreateFile(
		_T("\\\\.\\pciexdrvDevice"),
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		0,
		0
		);
	_ASSERTE(m_hDriver != INVALID_HANDLE_VALUE);

	if(m_hDriver == INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL, 
			"Failed to open the kernel-mode driver 'pciexdrv.sys'!\r\n\r\n"
			"Please make sure the driver is installed and started\r\n"
			"before restarting PCI Explorer.", 
			"PCI Explorer - Fatal Error!", MB_ICONERROR | MB_ICONSTOP | MB_OK);
	}

	m_pHostToPciBridge = NULL;
}

CPciExplorerDoc::~CPciExplorerDoc()
{
}

BOOL CPciExplorerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

void CPciExplorerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


#ifdef _DEBUG
void CPciExplorerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPciExplorerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

void CPciExplorerDoc::ScanPciBus()
{
	if(m_hDriver == INVALID_HANDLE_VALUE)
	{
		return;
	}

	// Delete the old Host/PCI bridge if any exist.
	delete m_pHostToPciBridge;

	// Create a new Host/PCI bridge object and scan the PCI bus.
	m_pHostToPciBridge = new CPciFunction(m_hDriver);

	// Update the views with the new information.
	UpdateAllViews(NULL, UPDATE_ALL_PCI_FUNCTIONS, (CObject*) m_pHostToPciBridge);
}



